function [] = CircleIntersectionsFill(XYR_OI,Color)

% XYR_OI is a matrix of circles, where the first column represents the X
% coordinates of the center of the circles, second column represents the Y
% coordinates, and the third column represents the circle's radius. The
% fourth column represents whether you want the outer or inner area: 1 =
% outer area, 0 = inner area.

% Color is a string used to define the fill color

% Example
% XYR_OI = [0,1,10,0; 10,0,3,1; 10,4,2,0];
% Color = 'b';

num_Points = 500;

arcs{1} = [XYR_OI(1,3)*cos(linspace(0,2*pi,num_Points))+XYR_OI(1,1); ...
    XYR_OI(1,3)*sin(linspace(0,2*pi,num_Points))+XYR_OI(1,2)]';

for i = 2:size(XYR_OI,1)
    arcs{i} = [XYR_OI(i,3)*cos(linspace(0,2*pi,num_Points))+XYR_OI(i,1); ...
        XYR_OI(i,3)*sin(linspace(0,2*pi,num_Points))+XYR_OI(i,2)]';
    for j = 1:i-1
        switch XYR_OI(i,4)
            case 0
                arcs{j} = arcs{j}(find(sqrt((XYR_OI(i,1)-arcs{j}(:,1)).^2+(XYR_OI(i,2)-arcs{j}(:,2)).^2)<XYR_OI(i,3)),:);
            case 1
                arcs{j} = arcs{j}(find(sqrt((XYR_OI(i,1)-arcs{j}(:,1)).^2+(XYR_OI(i,2)-arcs{j}(:,2)).^2)>XYR_OI(i,3)),:);
        end
        plot(arcs{j}(:,1),arcs{j}(:,2),'-r','LineWidth',2)
        switch XYR_OI(j,4)
            case 0
                arcs{i} = arcs{i}(find(sqrt((XYR_OI(j,1)-arcs{i}(:,1)).^2+(XYR_OI(j,2)-arcs{i}(:,2)).^2)<XYR_OI(j,3)),:);
            case 1
                arcs{i} = arcs{i}(find(sqrt((XYR_OI(j,1)-arcs{i}(:,1)).^2+(XYR_OI(j,2)-arcs{i}(:,2)).^2)>XYR_OI(j,3)),:);
        end
    end
end
i=1;
FillArea = arcs{i};
k = 1;
while k < size(XYR_OI,1)
for j = 1:size(XYR_OI,1)
    if i ~= j
i_end_j_start(j) = sqrt((arcs{i}(end,1)-arcs{j}(1,1))^2+(arcs{i}(end,2)-arcs{j}(1,2))^2);
i_end_j_end(j) = sqrt((arcs{i}(end,1)-arcs{j}(end,1))^2+(arcs{i}(end,2)-arcs{j}(end,2))^2);
    else
        i_end_j_start(j) = inf;
i_end_j_end(j) = inf;
    end
end
%next path is in correct order
if min(i_end_j_start) < min(i_end_j_end)
    [M,I] = min(i_end_j_start);
FillArea(end+1:end+size(arcs{I},1),:) = arcs{I};
else
    [M,I] = min(i_end_j_end);
FillArea(end+1:end+size(arcs{I}),:) = flip(arcs{I});
end
i = I;
k=k+1;
end

FillArea(end+1,:) = FillArea(1,:);
patch(FillArea(:,1),FillArea(:,2),Color)
end
